<!DOCTYPE html>
<html>

<head lang="es">
	<meta charset="utf-8">
	<title>Trabajo en grupo TG2</title>
	<link rel="stylesheet" href="style.css">
	<style>
		table,
		th,
		td {
			border: 1px solid black;
		}
	</style>
</head>

<body>
	<header>
		<h1>Desarrollo con Tecnologias Emergentes. Curso 2019-20<br>
			Trabajo TG2 del grupo M3<br>
			Titulo: TG2. Evaluar y comparar dos tecnologias emergentes</h1>
	</header>
	<nav>
		<ul>
			<li><a href="#1">1. Informacion general</a></li>
			<li><a href="#2">2. Descripcion de las tecnologias</a></li>
			<li><a href="#3">3. Criterios de comparacion</a></li>
			<li><a href="#4">4. Evaluacion de los criterios por categoria</a></li>
			<li><a href="#5">5. Comparacion de las tecnologias</a></li>
			<li><a href="#6">6. Recomendaciones</a></li>
		</ul>
	</nav>

	<main>
		<section id=1">
			<h2>1. Informacion general</h2>
			<h3>1.1 Autores</h3>
			<p>Grupo: M3</p>
				<p> Integrantes del grupo: Adina Murg (Product Owner), Arman Ananian Lalayan (Developer), 
					Adrián Valledor Pérez (Developer), Diego Lobo Bellón (Developer), Diego Gerardo Estalrich Cuellar (Developer)
			</p>
			<h3>1.2 Proyecto Scrum y repositorio en GitLab</h3>
			<p>URL Proyecto TG2 del grupo M3:
				<a href="https://gitlab.com/dte2020/m3/tg2/">URL proyecto M3</a>".</p>
			<h3>1.3 Burndown chart</h3>
			<p>Diagrama Burndown final del Sprint TG2:</p>
			<img src="burndownTG2.jpg">
			<h3>1.4 Presentacion del trabajo</h3>
			<p>Enlace al archivo de la presentación:</p>
			<a href="tg2.pptx">Presentacion con diapositivas del trabajo TG2</a></p>
		</section>
		<section id="2">
			<h2>2. Descripcion de las tecnologias</h2>
			<h3>2.1 Descripcion de la tecnologia Cheerio</h3>
			<p>Cheerio es una biblioteca Node.js, que nos permite realizar implementaciones más rápidas, flexibles y eficientes, gracias al empleo de 
				sintaxis jQuery (biblioteca multiplataforma de JavaScript cuyo objetivo es el de hacernos más facil el uso de JavaScript en nuestra web).
				Esta biblioteca nos permite analizar documentos HTML (la estructura de un documento) y extraer la información. Esta información posteriormente se puede 
				guardar en un archivo CSV, o bien se pueden extraer imágenes entre muchas otras opciones.
				El funcionamiento de Cheerio es muy simple, Cheerio analiza la web y prporciona una API para manipular la estructura de datos obtenida. Es importante destacar que no 
				interpreta el resultado como lo hace un navegador web.
			</p>
				<p>
					Algunos de los usos que se le pueden proporcionar pueden ser los de análisis de correos electrónicos, listas de deseos de Amazon/Aliexpress, seguimiento de tendencias de GitHub,
					análisis y seguimiento de precios de productos (enfocados en el e-commerce) y para detección de contenido sospechoso o análisis de contenidos en general.
				</p>
				<p>
					Destacamos también que Cheerio está bajo la MIT License, que nos permite hacer un uso privado y
					comercial de Cheerio además de poder distribuirlo y modificarlo. 
				</p>
				<p>
					Algunas empresas que hacen uso de esta tecnología son Walmart (para su web movil), Scraper API y Sysco Labs (para analizar páginas web scrapeadas),
					Courseoff (para scrapear cursos universitarios y sus horarios) y Cloudup (para proporcionar una mejor experiencia de visualización de su web) entre muchos otros.
					
				</p>
			<h3>2.2 Descripcion de la tecnologia Puppeteer </h3>
			<p> Puppeteer es una biblioteca Node.js que nos proporciona una API de alto nivel para automatizar y controlar Chrome a través del protocolo Chrome DevTools (conjunto de herramientas de creación y depuración web integradas en Google Chrome).
				Principalmente hace presencia en Chrome, pero también se puede emplear en Chromium, y está en proceso de desarrollo para poder emplearse en otros buscadores como Safari. Para utilizarlo hay que usar JavaScript de lenguaje.
				Puppeteer es una herramienta muy versatil que nos ayuda a la hora de monitorizar el comportamiento y rendimiento de nuestra web de una manera automática.

			</p>
			<p>
				Algunos de los usos que podemos darle a Puppeteer son: simulación de navegación web (automatizar procesos como el envío de formularios o el rellenado de datos),
				generar capturas de pantallas o informes PDF, creación de crawlers de páginas SPA o generar contenido pre-renderizado SSR, análisis de rendimiento de aplicaciones web,
				automatización de tests y probar extensiones de Chrome además de automatizar muchas más tareas.

			</p>
			<p>
				La licencia que emplea Puppeteer es la Apachache License 2.0, que nos permite, de la misma manera que Cheerio,
				el uso tanto privado como comercial además de permitirse tanto su modificación como distribución.
				
			</p>
			<img src="https://i.ibb.co/1dnnsnG/1c.png"alt=”Captura de ejemplo de Puppeteer” title=”Captura de ejemplo de Puppeteer” height="450" width="1000" />
			<a href="https://try-puppeteer.appspot.com/">Link web de simulación con código y ejemplo de salida de Puppeteer</a></p>
		</section>
		<section id="3">
			<h2>3. Criterios de comparacion</h2>
			
			<h3>3.1 Categoria A: General</h3>
			<h4>3.1.1 Criterio A.1: Licencias</h4>
			<ul>
				<li>Nombre del criterio: Licencias.</li>
				<li>Descripcion: Tipo de licencia de la que se dispone para su utilización.</li>
				<li>Tipo de valor: Texto libre.</li>
			</ul>
			<h4>3.1.2 Criterio A.2: Documentación oficial</h4>
			<ul>
				<li>Nombre del criterio: Documentación oficial</li>
				<li>Descripcion: Cantidad de documentación y fuente de procedencia.</li>
				<li>Tipo de valor: Texto libre. </li>
			</ul>
			<h4>3.1.3 Criterio A.3: Documentación no oficial</h4>
			<ul>
				<li>Nombre del criterio: Documentación no oficial</li>
				<li>Descripcion: Cantidad de documentación y origen de la misma.</li>
				<li>Tipo de valor: Texto libre. </li>
			</ul>
			<h4>3.1.4 Criterio A.4: Comunidad</h4>
			<ul>
				<li>Nombre del criterio: Comunidad</li>
				<li>Descripcion: Cantidad de comentarios en los foros, además de calidad de los mismos.</li>
				<li>Tipo de valor: Texto libre. </li>
			</ul>
			<h4>3.1.5 Criterio A.5: Requisitos previos</h4>
			<ul>
				<li>Nombre del criterio: Requisitos previos</li>
				<li>Descripcion: Enumeración de los diferentes requisitos, junto al nombre de los mismos.</li>
				<li>Tipo de valor: Texto libre. </li>
			</ul>
			<h4>3.1.6 Criterio A.6: Competidores</h4>
			<ul>
				<li>Nombre del criterio: Competidores</li>
				<li>Descripcion: Enumeración de algunos de los principales competidores reconocidos.</li>
				<li>Tipo de valor: Texto libre. </li>
			</ul>
			<h4>3.1.7 Criterio A.7: Madurez</h4>
			<ul>
				<li>Nombre del criterio: Madurez</li>
				<li>Descripcion: Número de la última versión de la herramienta.</li>
				<li>Tipo de valor: Numérico. </li>
			</ul>
			<h4>3.1.8 Criterio A.8: Adaptabilidad</h4>
			<ul>
				<li>Nombre del criterio: Adaptabilidad</li>
				<li>Descripcion: Capacidad de uso a través de diferentes navegadores y entornos.</li>
				<li>Tipo de valor: Texto libre. </li>
			</ul>
			<h4>3.1.9 Criterio A.9: Soporte</h4>
			<ul>
				<li>Nombre del criterio: Soporte</li>
				<li>Descripcion: Existencia o no de un correo o forma de contacto oficial.</li>
				<li>Tipo de valor: Booleano. </li>
			</ul>
			<h4>3.1.10 Criterio A.10: Experiencia de usuario</h4>
			<ul>
				<li>Nombre del criterio: Experiencia de usuario</li>
				<li>Descripcion: Valoración de la experiencia del usuario en una escala numérica entre 0 y 5.</li>
				<li>Tipo de valor: Numérico. </li>
			</ul>
			<h3>3.2 Categoria B: Implementación y desarrollo</h3>
			<h4>3.2.1 Criterio B.1: Líneas de código</h4>
			<ul>
				<li>Nombre del criterio: Líneas de código.</li>
				<li>Descripcion: Cantidad media de líneas de código necesarias para su uso.</li>
				<li>Tipo de valor: Texto libre.</li>
			</ul>

			<h4>3.2.2 Criterio B.2: Curva de aprendizaje</h4>
			<ul>
				<li>Nombre del criterio: Curva de aprendizaje</li>
				<li>Descripcion: Tiempo medio en adquirir los conocimientos necesarios para su implementación.</li>
				<li>Tipo de valor: Numerico.</li>
			</ul>
			<h4>3.2.3 Criterio B.3: Versatilidad</h4>
			<ul>
				<li>Nombre del criterio: Versatilidad</li>
				<li>Descripcion: Capacidad de uso para diferentes proyectos.</li>
				<li>Tipo de valor: Texto libre.</li>
			</ul>
			<h4>3.2.4 Criterio B.4: Lenguaje de desarrollo</h4>
			<ul>
				<li>Nombre del criterio: Lenguaje de desarrollo</li>
				<li>Descripcion: Dificultad de uso del lenguaje que se ha de usar para desarrollar la tecnología.</li>
				<li>Tipo de valor: Texto libre.</li>
			</ul>
			<h4>3.2.5 Criterio B.5: Lenguaje a utilizar</h4>
			<ul>
				<li>Nombre del criterio: Lenguaje a utilizar</li>
				<li>Descripcion: Dificultad del lenguaje para explicar los procedimientos.</li>
				<li>Tipo de valor: Texto libre.</li>
			</ul>
			<h4>3.2.6 Criterio B.6: Integracion</h4>
			<ul>
				<li>Nombre del criterio: Integracion</li>
				<li>Descripcion: Capacidad de integrar la tecnología con otros programas web o de escritorio.</li>
				<li>Tipo de valor: Booleano.</li>
			</ul>
			<h4>3.2.7 Criterio B.7: Escalabilidad</h4>
			<ul>
				<li>Nombre del criterio: Escalabilidad</li>
				<li>Descripcion: Capacidad de incrementar el uso considerablemente sin perder rendimiento.</li>
				<li>Tipo de valor: Booleano.</li>
			</ul>

			<h3>3.3 Categoria C: Criterios técnicos</h3>
			<h4>3.3.1 Criterio C.1: Requerimientos de software</h4>
			<ul>
				<li>Nombre del criterio: Requerimientos de software</li>
				<li>Descripcion: Necesidad de disponer de un entorno o navegador específico.</li>
				<li>Tipo de valor: Booleano.</li>
			</ul>
			<h4>3.3.2 Criterio C.2: Instalación</h4>
			<ul>
				<li>Nombre del criterio: Instalación</li>
				<li>Descripcion: Capacidad de instalarse fácilmente. </li>
				<li>Tipo de valor: Booleano.</li>
			</ul>
			<h4>3.3.3 Criterio C.3: Configuración</h4>
			<ul>
				<li>Nombre del criterio: Configuración</li>
				<li>Descripcion: Facilidad de adaptación al objetivo.</li>
				<li>Tipo de valor: Booleano.</li>
			</ul>
			<h4>3.3.4 Criterio C.4: Necesidad de complementos</h4>
			<ul>
				<li>Nombre del criterio: Necesidad de complementos</li>
				<li>Descripcion: Uso de funcionalidad adicional para completar la tecnologia.</li>
				<li>Tipo de valor: Booleano.</li>
			</ul>
			<h4>3.3.5 Criterio C.5: Variedad de funcionalidades	</h4>
			<ul>
				<li>Nombre del criterio: Variedad de funcionalidades.</li>
				<li>Descripcion: Conjunto aproximado de operaciones distintas de cada tecnología.</li>
				<li>Tipo de valor: Texto libre.</li>
			</ul>


			
			

		</section>

		<section id="4">
			<h2>4. Evaluación de los criterios por categoría</h2>
			<h3>4.1 Evaluación de los criterios para la tecnología Puppeteer</h3>
		
			<table>
				<tr>
					<th>Criterio</th>
					<th>Evaluación</th>
				</tr>
				<tr>
					<td>Criterio A.1: Licencias</td>
					<td>Apache 2.0</td>
				</tr>
				<tr>
					<td>Criterio A.2: Documentación oficial</td>
					<td>Si.  <a href="https://github.com/puppeteer/puppeteer">https://github.com/puppeteer/puppeteer</a></td>
					
				</tr>
				<tr>
					<td>Criterio A.3: Documentación no oficial</td>
					<td>Si.  <a href="https://jestjs.io/docs/en/puppeteer">https://jestjs.io/docs/en/puppeteer</a></td>
				</tr>
				<tr>
					<td>Criterio A.4: Comunidad</td>
					<td>Si, comunidad de github.</td>
				</tr>
				<tr>
					<td>Criterio A.5: Requisitos previos</td>
					<td>Instalar Node.js y entorno de desarrollo Phyton.</td>
				</tr>
				<tr>
					<td>Criterio A.6: Competidores</td>
					<td>Cheerio, Request-Promise, Nightmare, Osmosis.</td>
				</tr>
				<tr>
					<td>Criterio A.7: Madurez</td>
					<td>Versión 2.1.1.</td>
				</tr>
				<tr>
					<td>Criterio A.8: Adaptabilidad</td>
					<td>Si, Chrome o Chromium.</td>
				</tr>
				<tr>
					<td>Criterio A.9: Soporte</td>
					<td>No.</td>
				</tr>
				<tr>
					<td>Criterio A.10: Experiencia de usuario</td>
					<td>3,5.</td>
				</tr>
				<tr>
					<td>Criterio B.1: Líneas de código</td>
					<td>Número de líneas en html propias de la web.</td>
				</tr>
				<tr>
					<td>Criterio B.2: Curva de aprendizaje</td>
					<td>2 semanas dada la necesidad de introducirese de forma muy leve en lenguaje HTML o Python.</td>
				</tr>
				<tr>
					<td>Criterio B.3: Versatilidad</td>
					<td>Alta, fácil reutilización.</td>
				</tr>
				<tr>
					<td>Criterio B.4: Lenguaje de desarrollo</td>
					<td>JavaScript en su mayoría.</td>
				</tr>
				<tr>
					<td>Criterio B.5: Lenguaje a utilizar</td>
					<td>HTML y/o Python</td>
				</tr>
				<tr>
					<td>Criterio B.6: Integración</td>
					<td>Si</td>
				</tr>
				<tr>
					<td>Criterio B.7: Escalabilidad</td>
					<td>Si, usando herramientas como apify.com.</td>
				</tr>
				<tr>
					<td>Criterio C.1: Requerimientos de software</td>
					<td>Si</td>
				</tr>
				<tr>
					<td>Criterio C.2: Instalación</td>
					<td>Si</td>
				</tr>
				<tr>
					<td>Criterio C.3: Configuración</td>
					<td>Si</td>
				</tr>
				<tr>
					<td>Criterio C.4: Necesidad de complementos</td>
					<td>Si, Node.js y extensiones de Google Chrome.</td>
				</tr>
				<tr>
					<td>Criterio C.5: Variedad de funcionalidades</td>
					<td>Navegador completo, puede realizar funciones avanzadas.</td>
				</tr>
			</table>


			<h3>4.2 Evaluacion de los criterios para la Cheerio</h3>

			<table>
				<tr>
					<th>Criterio</th>
					<th>Evaluacion</th>
				</tr>
				<tr>
					<td>Criterio A.1: Licencias</td>
					<td>MIT, permite utilizarse manteniendo la firma de copyright.</td>
				</tr>
				<tr>
					<td>Criterio A.2: Documentación oficial</td>
					
					<td>Si.  <a href="https://cheerio.js.org/">https://cheerio.js.org/</a></td>
					
				</tr>
				<tr>
					<td>Criterio A.3: Documentación no oficial</td>
					<td>Si.  <a href="http://zetcode.com/javascript/cheerio/">http://zetcode.com/javascript/cheerio/</a></td>
				</tr>
				<tr>
					<td>Criterio A.4: Comunidad</td>
					<td>Si, Github.</td>
				</tr>
				<tr>
					<td>Criterio A.5: Requisitos previos</td>
					<td>Instalar Node.js y entorno de desarrollo Python.</td>
				</tr>
				<tr>
					<td>Criterio A.6: Competidores</td>
					<td>Puppeteer, Request-Promise, Nightmare, Osmosis</td>
				</tr>
				<tr>
					<td>Criterio A.7: Madurez</td>
					<td>Versión 1.0.0</td>
				</tr>
				<tr>
					<td>Criterio A.8: Adaptabilidad</td>
					<td>No usa navegador</td>
				</tr>
				<tr>
					<td>Criterio A.9: Soporte</td>
					<td>No</td>
				</tr>
				<tr>
					<td>Criterio A.10: Experiencia de usuario</td>
					<td>3,5</td>
				</tr>
				<tr>
					<td>Criterio B.1: Líneas de código</td>
					<td>Número de líneas en html propias de la web.</td>
				</tr>
				<tr>
					<td>Criterio B.2: Curva de aprendizaje</td>
					<td>2 semanas dada la necesidad de introducirse de forma muy leve en lenguaje html o python.</td>
				</tr>
				<tr>
					<td>Criterio B.3: Versatilidad</td>
					<td>Alta, fácil reutilización.</td>
				</tr>
				<tr>
					<td>Criterio B.4: Lenguaje de desarrollo</td>
					<td>Javascript en su mayoría.</td>
				</tr>
				<tr>
					<td>Criterio B.5: Lenguaje a utilizar</td>
					<td>HTML y/o Python</td>
				</tr>
				<tr>
					<td>Criterio B.6: Integración</td>
					<td>No</td>
				</tr>
				<tr>
					<td>Criterio B.7: Escalabilidad</td>
					<td>Si, usando herramientas como apify.com</td>
				</tr>
				<tr>
					<td>Criterio C.1: Requerimientos de software</td>
					<td>Si</td>
				</tr>
				<tr>
					<td>Criterio C.2: Instalación</td>
					<td>Si</td>
				</tr>
				<tr>
					<td>Criterio C.3: Configuración</td>
					<td>Si</td>
				</tr>
				<tr>
					<td>Criterio C.4: Necesidad de complementos</td>
					<td>Si, Node.js</td>
				</tr>
				<tr>
					<td>Criterio C.5: Variedad de funcionalidades</td>
					<td>Se trata de un Parser, funciona bien en la mayoría de casos pero no tiene un navegador integrado</td>
				</tr>

			</table>

			<p>Incluimos fuentes y enlaces en cada una de las líneas de la tabla</p>

		</section>

		<section id="5">
			<h2>5. Comparacion de las tecnologias</h2>
			<table>
				<tr>
					<th>Criterio</th>
					<th>Tecnologia 1: Puppeteer</th>
					<th>Tecnologia 2: Cheerio</th>
					<th>Comentarios</th>

				</tr>
				<tr>
					<td>A.1.Licencias</td>
					<td>Apache 2.0</td>
					<td>MIT</td>
					<td>La licencia MIT es ligeramente más permisiva. 
						Ambas herramientas son gratuitas y permiten su uso comercial</td>
				</tr>
				<tr>
					<td>A.2.Documentación oficial</td>
					<td><a href="https://github.com/puppeteer/puppeteer">https://github.com/puppeteer/puppeteer</a></td>
					<td><a href="https://cheerio.js.org/">https://cheerio.js.org/</a></td>
					<td>Cheerio cuenta con página propia además de su propio repositorio Git mientras que puppeteer solo está en Git</td>
				</tr>
				<tr>
					<td>A.3.Documentación no oficial</td>
					<td><a href="https://jestjs.io/docs/en/puppeteer">https://jestjs.io/docs/en/puppeteer</a></td>
					<td><a href="http://zetcode.com/javascript/cheerio/">http://zetcode.com/javascript/cheerio/</a></td>
					<td>Ambas se enfocan en el ámbito práctico. 
						Ambas cuentan con una moderada presencia en la web, con gran cantidad de información tanto
						de su instalación, implementación, como de ejemplos prácticos para visualizar sus capacidades</td>
				</tr>
				<tr>
					<td>A.4.Comunidad</td>
					<td>Si, en Github</td>
					<td>Si, en Github</td>
					<td>Ambas teccnologías cuentan con una gran comunidad en Github, que no solo se encargan de apoyar financieramente las herramientas
						si no que además se encargan de proporcionar nuevos módulos e implementaciones de forma constante. La participación de ambas comunidades
						es muy activa y libre, cualquiera puede realizar aportaciones
						</td>

				</tr>
				<tr>
					<td>A.5.Requisitos previos</td>
					<td>Node.js + entorno de desarrollo python </td>
					<td>Node.js + entorno de desarrollo python </td>
					<td>Ambas necesitan Node.js y un entorno de desarrollo python como requisitos previos</td>

				</tr>
				<tr>
					<td>A.6.Competidores</td>
					<td>Cheerio, Request-Promise, Nightmare, Osmosis</td>
					<td>Puppeteer, Request-Promise, Nightmare, Osmosis</td>
					<td>Las tecnologías son competidoras entre si. Cheerio cuenta con 4.095.931 descargas semanales mientras que Puppeteer cuenta con 1.320.459.
						Más información en la imagen adjunta A.6.Img1</td>

				</tr>
				<tr>
					<td>A.7.Madurez</th>
					<td>Versión 2.1.1</td>
					<td>Versión 1.0.0</td>
					<td>Cheerio está en su primera versión, mientras que Puppeteer es más madura</td>

				</tr>
				<tr>
					<td>A.8.Adaptabilidad</td>
					<td>Chrome o Chromium</td>
					<td>No utiliza navegador</td>
					<td>La tecnología Puppeteer muestra mayor adaptabilidad frente a Cheerio</td>

				</tr>
				<tr>
					<td>A.9.Soporte</td>
					<td>No</td>
					<td>No</td>
					<td>Ninguna de las tecnologías cuenta con soporte oficial para el desarrollo</td>

				</tr>
				<tr>
					<td>A.10.Experiencia de usuario</td>
					<td>3,5 (60192 Stars)</td>
					<td>3,5 (21701 Stars)</td>
					<td>La experiencia de usuario es similar para ambas tecnologías. A pesar de que Cherio cuenta con más descargas que 
						Puppeteer, Puppeteer cuenta con mejor valoración que Cheerio. Más información en la imagen adjunta A.10.Img1
					</td>

				</tr>
				<tr>
					<td>B.1.Líneas de código</td>
					<td>Número de lineas en html propias de la web</td>
					<td>Número de líneas en html propias de la web</td>
					<td>Las líneas de código necesarias son similares</td>

				</tr>
				<tr>
					<td>B.2.Curva de aprendizaje</td>
					<td>2 semanas dada la necesidad de introducirese de forma muy leve en lenguaje HTML o Python.</td>
					<td>2 semanas dada la necesidad de introducirese de forma muy leve en lenguaje HTML o Python.</td>
					<td>La curva de aprendizaje es rápida para ambas tecnologías</td>

				</tr>
				<tr>
					<td>B.3.Versatilidad</td>
					<td>Alta, fácil reutilización</td>
					<td>Alta, fácil reutilización</td>
					<td>Ambas tecnologías son versátiles y permiten la reutilización del código</td>

				</tr>
				<tr>
					<td>B.4.Lenguaje de desarrollo</td>
					<td>JavaScript en su mayoría</td>
					<td>JavaScript en su mayoría</td>
					<td>Ambas tecnologías utilizan JavaScript mayoritariamente</td>

				</tr>
				<tr>
					<td>B.5.Lenguaje a utilizar</td>
					<td>html y/o python</td>
					<td>html y/o python</td>
					<td>Ambas tecnologías permiten utilizar html o python como lenguaje</td>

				</tr>
				<tr>
					<td>B.6.integración</td>
					<td>Si</td>
					<td>No</td>
					<td>La tecnología de Cheerio no cuenta con integración</td>

				</tr>
				<tr>
					<td>B.7.Escalabilidad</td>
					<td>Si, usando herramientas como apify.com</td>
					<td>Si, usando herramientas como apify.com</td>
					<td>Ambas tecnologías permiten el escalado mediante el uso de aplicaciones de terceros</td>

				</tr>
				<tr>
					<td>C.1.Requerimientos de software</td>
					<td>Si</td>
					<td>Si</td>
					<td>Ambas tecnologías tienen requerimientos de software similares. Puppeteer sí requiere el uso específico de Chrome o Chromium</td>

				</tr>
				<tr>
					<td>C.2.Instalación</td>
					<td>Si</td>
					<td>Si</td>
					<td>Ambas tecnologías requieren de instalación para ser utilizadas. No hay soporte de editores online que las traten</td>

				</tr>
				<tr>
					<td>C.3.Configuración</td>
					<td>Si</td>
					<td>Si</td>
					<td>Ambas tecnologías permiten su configuración y modificación para adaptarse al proyecto de forma específica</td>

				</tr>
				<tr>
					<td>C.4.Necesidad de complementos</td>
					<td>Si, Node.js y extensiones de Google Chrome</td>
					<td>Si, Node.js</td>
					<td>Es necesario utilizar Node.js junto con ambas tecnologías. La tecnología a requiere de más complementos</td>

				</tr>
				<tr>
					<td>C.5.Variedad de funcionalidades</td>
					<td>Avanzado</td>
					<td>Más limitado</td>
					<td>Puppeteer funciona como un navegador, mientras que Cheerio no</td>

				</tr>
			</table>




			<p>
				A.6.img1: Imagen que nos muestra la popularidad de cheerio vs puppeteer vs osmosis vs nightmare vs request-promise
				medido en descargas a lo largo de los últimos 2 años. Como podemos comprobar, Cheerio va en cabeza.
				Lo obtenemos de la página npm Trends. Npm es una ramificación de git que contiene diversa información oficial de los repositorios de git.
			</p>
			<img src="https://i.ibb.co/RHK6N9v/1a.png"alt=”A.6.Img1” title=”A.10.Img1” width="”1084”" height="”339”"/></p>
			</p><a href="https://www.npmtrends.com/cheerio-vs-puppeteer-vs-osmosis-vs-nightmare-vs-request-promise">https://www.npmtrends.com/cheerio-vs-puppeteer-vs-osmosis-vs-nightmare-vs-request-promise</a></p>


<p>
				A.10.img1: Imagen que nos muestra la popularidad (experiencia de ususario) de las tecnologías. Tambiénla obtenemos de npm Trends.
			</p>
			<img src="https://i.ibb.co/xFph7Lb/1b.png"alt=”A.6.Img1” title=”A.10.Img1”/></p>
			</p><a href="https://www.npmtrends.com/cheerio-vs-puppeteer-vs-osmosis-vs-nightmare-vs-request-promise">https://www.npmtrends.com/cheerio-vs-puppeteer-vs-osmosis-vs-nightmare-vs-request-promise</a></p>


		</section>

		<section id="6">
			<h2>6. Recomendaciones</h2>
			<p></p>
			<h3>6.1 Situacion A</h3>
			<h4>6.1.1 Descripcion de la situacion</h4>
			<p> En esta primera situación nos pondremos en el caso de una empresa que se dedica al sector de la educación 
				para la impartición de cursos online sobre asignaturas orientadas a estudiantes de instituto.
				Para ello necesitará elegir una tecnología para realizar extracción de información de páginas web 
				de una forma segura y profunda, teniendo en cuenta que vamos a usar webs complejas. Dicha empresa posee suficientes recursos
				de CPU y memoria pero disponen de un limitado equipo de informáticos con conocimientos no muy extensos sobre la tecnología.
			</p>
			<h4>6.1.2 Recomendacion de la tecnología a utilizar</h4>
			<p>En este caso deberíamos usar la herramienta Puppeteer.
				Puppeteer iniciaría instancias de Chromium o Chrome por lo que nos mostraría
				así que lo que muestra en la página es exactamente lo que se vería en el navegador sin diferencias.
				Por otro lado,Puppeteer debe cargar completamente la página de Chromium lo que significa 
				que carga todos los recursos de la página, incluso si tiene que mirar el código fuente html inicial. 
				Esto consume tiempo, ancho de banda y requiere recursos de la máquina (tanto CPU como memoria). Aunque 
				como bien se ha mencionado, esto no nos supone ningún problema.
			</p>
			
			<table>
				<tr>
					<th>Criterios relevantes para la decision</th>
					<th>Ventajas tecnología Puppeteer</th>
					<th>Ventajas tecnología Cheerio</th>
				</tr>
				<tr>
					<td>A.7 Madurez.</td>
					<td>En el caso de Puppeteer, es más madura con más posibilidades, carácteristicas y funciones,
						(dado que cada vez que se agrega un conjunto de nuevas características y funciones sale  una versión actualizada de la aplicación).
					</td>
					<td>No cuenta con tantas posibilidades.</td>
				</tr>
				<tr>
					<td>A.8 Adaptabilidad.</td>
					<td>Cuenta con una buena adaptabilidad, con lo que asegura mayor versatilidad.</td>
					<td>Adaptabilidad reducida, también cuenta con menos posibilidades por esto. No funciona como navegador web.</td>
				</tr>
				<tr>
					<td>C.5 Variedad de funcionalidades.</td>
					<td>Alto número de funcionalidades diferentes. Nos permite por ejemplo, inyectar archivos JavaScript en páginas (Cheerio no lo permite) 
						También, dado a que emplea Chromium, nos permite interactura con métodos o variables de JavaScript para analizarlos de forma más sencilla dado que 
						tenemos acceso total al código (con Cherrio este proceso es mucho más complejo y lento ya que requiere un tratamiento diferente).

					</td>
					<td>Funcionalidades reducidas.</td>
				</tr>
			</table>

			Como hemos visto en la tabla, si quisieramos realizar una extracción de información de sitios web de manera segura y profunda, es decir, en varios sitios web que tengan
			diferentes características y complejidades, recomendamos el uso de Puppeteerya que cuenta con más ventajas a la hora de realizar esto, ya que Cheerio es más reducido 
			en posibilidades por lo que nos puede ocasionar problemas.

			<h3>6.2 Situacion B</h3>
			<h4>6.2.1 Descripcion de la situacion</h4>
			<p>Supongamos que somos un grupo de personas que queremos lanzar una plataforma en la que compararemos distintos precios de compra de diferentes páginas web para 
				facilitar al usuario dónde comprar más barato. Necesitamos realizar una extracción de información de una gran cantidad de sitios web y de una forma rápida.
				Necesitamos saber si usar Puppeteer o Cheerio.
			</p>
			<h4>6.2.2 Recomendacion de la tecnología a utilizar</h4>
			<p>En este caso deberíamos usar la tecnología Cheerio.</p>
		
			<table>
				<tr>
					<th>Criterios relevantes para la decision</th>
					<th>Ventajas tecnología Puppeteer</th>
					<th>Ventajas tecnología Cheerio</th>
				</tr>

				<tr>
					<td>A.5 Requisitos previos.</td>
					<td>Con Puppeteer necesitaremos Node.js y un entorno de desarrollo html o python.</td>
					<td>Al igual que Puppeteer, con Cheerio también necesitaremos Node.js y un entorno de desarrollo html o python.</td>
				</tr>
				<tr>
					<td>C.1 Requerimientos software.</td>
					<td>Puppeteer tiene requerimientos software. En su caso es más concreta, ya que se usará en Chrome o Chromium.</td>
					<td>Aunque también tenga ciertos requerimientos software, no está ligada a usarse en Chrome o Chromium.</td>
				</tr>
				<tr>
					<td>C.4 Necesidad de complementos.</td>
					<td>Necesitamos Node.js y extensiones de Google Chrome ya que solo se puede utilizar en Chrome o Chromium.</td>
					<td>En el caso de Cheerio solo necesitamos Node.js y no requiere de más complementos.</td>
				</tr>
				<tr>
					<td>C.5 Variedad de funcionalidades.</td>
					<td>Puppeteer cuenta con mayor variedad de funcionalidades, por lo que aumentará un poco el tiempo para familiarizarse con la herramienta.</td>
					<td>Cheerio tiene unas funcionalidades más reducidad, por lo que será más rápido la familiarización con esta herramienta.</td>
				</tr>
			</table>


			<p>Aunque ambas tecnologías sean parecidas, lo correcto sería usar Cheerio en este caso, ya que es una herramienta enfocada a la rapidez, que es justo lo 
			que necesitamos en el caso que hemos descrito, ya que lo que vamos a realizar es una extracción de información de sitios web muy similares continuamente,
			no nos interesan muchas funcionalidades que no vamos a usar ya que en este caso prima la rapidez para realizar esta extracción de datos en una gran cantidad de sitios.</p>
		
			<h3>6.3 Anexo sobre Puppeteer y Cheerio</h3>

			<p>Es complicado imaginar situaciones en los que tener que elegir entre una tecnología u otra, ya que como hemos visto en el punto 5, tanto Puppeteer como Cheerio
			son muy parecidas. Las únicas diferencias más notables son por un lado que Puppeteer es algo más versátil y cuenta más funcionalidades que Cheerio y por otro lado 
			que Cheerio presenta cierta ventaja en cuando a rapidez a la hora de realizar extracción de datos en páginas web pese a que puede fallar si queremos realizar esto en
			páginas web complejas que cuenten por ejemplo con un manejo complejo de las cookies, o si necesitas realizar tareas complejas como detección de características de imágenes.</p>
		</section>



	</main>

</body>

</html>
